# -*- coding: utf-8 -*-
# Generated by Django 1.10.3 on 2017-04-07 07:54
from __future__ import unicode_literals

from django.db import migrations, models


def auto_remove_scipost_physics_proc(apps, schema_editor):
    Journal = apps.get_model('journals', 'Journal')
    try:
        journal = Journal.objects.get(name='SciPostPhysProc')
        journal.delete()
        print('\n   - SciPost Physics Proceedings deleted...')
    except Journal.DoesNotExist:
        print('   - No SciPost Physics Proceedings does not exist...')


def auto_add_scipost_physics_proc(apps, schema_editor):
    Journal = apps.get_model('journals', 'Journal')
    Journal.objects.create(name='SciPostPhysProc', doi_string='SciPostPhysProc')
    print('   - SciPost Physics Proceedings created...')


def alter_existing_journal_name(apps, schema_editor):
    Journal = apps.get_model('journals', 'Journal')
    Submission = apps.get_model('submissions', 'Submission')
    try:
        journal = Journal.objects.get(name='SciPost Physics')
        journal.name = 'SciPostPhys'
        journal.save()
        print('\n   - SciPost Physics name updated...')

        Submission.objects.filter(submitted_to_journal='SciPost Physics').update(
                                  submitted_to_journal='SciPostPhys'
        )
        Submission.objects.filter(submitted_to_journal='SciPost Physics Lecture Notes').update(
                                  submitted_to_journal='SciPostPhysLectNotes'
        )
        print('   - Submission `submitted_to_journal` keys updated...')
    except Journal.DoesNotExist:
        print('   - No Journal Names altered...')


def reverse_alter_existing_journal_name(apps, schema_editor):
    Journal = apps.get_model('journals', 'Journal')
    Submission = apps.get_model('submissions', 'Submission')
    try:
        journal = Journal.objects.get(name='SciPostPhys')
        journal.name = 'SciPost Physics'
        journal.save()
        print('   - SciPost Physics name updated...')

        Submission.objects.filter(submitted_to_journal='SciPostPhys').update(
                                  submitted_to_journal='SciPost Physics'
        )
        Submission.objects.filter(submitted_to_journal='SciPostPhysLectNotes').update(
                                  submitted_to_journal='SciPost Physics Lecture Notes'
        )
        print('   - Submission `submitted_to_journal` keys updated...')
    except Journal.DoesNotExist:
        print('   - No Journal Names altered...')


class Migration(migrations.Migration):

    dependencies = [
        ('journals', '0012_auto_20170407_0926'),
    ]

    operations = [
        migrations.RunPython(alter_existing_journal_name, reverse_alter_existing_journal_name),
        migrations.AlterField(
            model_name='journal',
            name='name',
            field=models.CharField(choices=[('SciPostPhys', 'SciPost Physics'), ('SciPostPhysLectNotes', 'SciPost Physics Lecture Notes'), ('SciPostPhysSel', 'SciPost Physics Select'), ('SciPostPhysProc', 'SciPost Physics Proceedings')], max_length=100, unique=True),
        ),
        migrations.RunPython(auto_add_scipost_physics_proc, auto_remove_scipost_physics_proc),
    ]
